Wiskas = {}

if GetLocale() == "ruRU" then
	Wiskas.nfont = [=[Interface\AddOns\oUF_Wiskas\media\altmono.ttf]=]
else
	Wiskas.nfont = [=[Interface\AddOns\oUF_Wiskas\media\mono.ttf]=]
end

Wiskas.sfont = [=[Fonts\FRIZQT__.ttf]=]
Wiskas.colormain = {.022,.022,.022,1}
Wiskas.colorshadow = {.11,.11,.11,1}

Wiskas.textureblank =  [=[Interface\AddOns\oUF_Wiskas\media\blankTex]=]
Wiskas.textureglow = [=[Interface\AddOns\oUF_Wiskas\media\glowTex]=]
Wiskas.texturewall = [=[Interface\AddOns\oUF_Wiskas\media\wallTex]=]

Wiskas.ufscale = 1
if not (HissyData) then
	if GetCVar("UseUIScale") == "1" then
		Wiskas.ufscale = (768/string.match(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)"))/GetCVar("UIScale")
	end
end

Wiskas.mkButton = function (myframe,offset,nobg,blend)
	local offset = offset or 3
	
	if nobg ~= true then
		myframe.bg = myframe:CreateTexture(nil,"BORDER")
		myframe.bg:SetPoint("TOPLEFT",offset+1,-offset-1)
		myframe.bg:SetPoint("BOTTOMRIGHT",-offset-1,offset+1)
		myframe.bg:SetTexture(Wiskas.textureblank)
		myframe.bg:SetGradientAlpha("VERTICAL",.26,.26,.26,.14,.21,.21,.21,.47)
		myframe.bg:SetBlendMode(blend or "ADD")
	end
	
		myframe.left = myframe:CreateTexture(nil,"OVERLAY")
		myframe.left:SetTexture(0,0,0)
		myframe.left:SetPoint("TOPLEFT",offset,-offset)
		myframe.left:SetPoint("BOTTOMLEFT",offset,offset)
		myframe.left:SetWidth(1)
		
		myframe.right = myframe:CreateTexture(nil,"OVERLAY")
		myframe.right:SetTexture(0,0,0)
		myframe.right:SetPoint("TOPRIGHT",-offset,-offset)
		myframe.right:SetPoint("BOTTOMRIGHT",-offset,offset)
		myframe.right:SetWidth(1)
		myframe.bottom = myframe:CreateTexture(nil,"OVERLAY")
		
		myframe.bottom:SetTexture(0,0,0)
		myframe.bottom:SetPoint("BOTTOMLEFT",offset,offset)
		myframe.bottom:SetPoint("BOTTOMRIGHT",-offset,offset)
		myframe.bottom:SetHeight(1)
		
		myframe.top = myframe:CreateTexture(nil,"OVERLAY")
		myframe.top:SetTexture(0,0,0)
		myframe.top:SetPoint("TOPLEFT",offset,-offset)
		myframe.top:SetPoint("TOPRIGHT",-offset,offset)
		myframe.top:SetHeight(1)
		
	return myframe

end

Wiskas.frame = function(parent,strata,level)

	local lolframe = CreateFrame ("Frame",nil,parent)
	lolframe:SetFrameLevel(level or 1)
	if (strata) then lolframe:SetFrameStrata(strata) end
	
	lolframe:SetBackdrop ( { bgFile = Wiskas.textureblank, 
							 edgeFile = Wiskas.textureglow, 
							 edgeSize = 4, 
							 insets = { left = 3, right = 3, top = 3, bottom = 3 } })
							 
	lolframe:SetBackdropBorderColor(unpack(Wiskas.colorshadow))
	lolframe:SetBackdropColor(unpack(Wiskas.colormain))
	
	lolframe = Wiskas.mkButton(lolframe)
	
	return lolframe
end

colors = setmetatable({
	power = setmetatable({
	["MANA"] = {.2, .4, 1},
	["RAGE"] = {.9, .1, .1},
	["FUEL"] = {0, 0.55, 0.5},
	["FOCUS"] = {.9, .9, .1},
	["ENERGY"] = {.9, .9, .1},
	["AMMOSLOT"] = {0.8, 0.6, 0},
	["RUNIC_POWER"] = {.1, .9, .9},
	["POWER_TYPE_STEAM"] = {0.55, 0.57, 0.61},
	["POWER_TYPE_PYRITE"] = {0.60, 0.09, 0.17},
  }, {__index = oUF.colors.power}),
	happiness = setmetatable({
	[1] = {0.93,0.07,0.07},
	[2] = {0.93,0.93,0.07},
	[3] = {0.07, 0.93, 0.07},
	}, {__index = oUF.colors.happiness}),
	runes = setmetatable({
    [1] = {0.8, 0, 0},
    [3] = {0, 0.4, 0.7},
    [4] = {0.8, 0.8, 0.8}
  }, {__index = oUF.colors.runes})
}, {__index = oUF.colors})

Wiskas.auraIcon = function(icons, button)
	icons.showDebuffType = true
	icons.disableCooldown = false
	
	button.icon:SetTexCoord(.1, .9, .1, .9)
	button.icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)
	button.icon:SetPoint("TOPLEFT", button,1,-1)
	button.icon:SetPoint("BOTTOMRIGHT", button,-1,1)
	
	button.overlay:SetTexture(nil)
	
	button.glow = CreateFrame ("Frame",nil,button)
	button.glow:SetPoint("TOPLEFT",-3,3)
	button.glow:SetFrameLevel(0)
	button.glow:SetPoint("BOTTOMRIGHT",3,-3)
	button.glow:SetBackdrop ( {
		bgfile = Wiskas.textureblank,
	  edgeFile = Wiskas.textureglow, 
	  edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }
	})
	button.glow = Wiskas.mkButton (button.glow,nil,true)
	
	button.cd:SetReverse()
	button.cd:SetPoint("TOPLEFT", button.icon)
	button.cd:SetPoint("BOTTOMRIGHT", button.icon)

	button.count:ClearAllPoints()
	button.count:SetPoint("TOPRIGHT", button, "TOPRIGHT",.3,1.3)
	button.count:SetJustifyH("RIGHT")
	button.count:SetFont(Wiskas.nfont, button:GetWidth()/2.2, "OUTLINE")
	button.count:SetShadowOffset(1,-1)
	button.count:SetTextColor(1, 1, 1)
	
	if icons.cc_font_size then
		button.cc_font_size = icons.cc_font_size
	end
	
	if icons.cbt then 
		button.bottomcooldown = true
		button.count:ClearAllPoints()
		button.count:SetPoint("BOTTOMLEFT", button,.3,1.5)
		button.count:SetJustifyH("LEFT")
	end	
end

local r,g,b,sh = unpack(Wiskas.colorshadow)

Wiskas.auraUpdateIcon = function(_, _, icon)
	 if (icon.debuff) then
		local r,g,b = icon.overlay:GetVertexColor()
		icon.glow:SetBackdropBorderColor(r,g,b,.6)
		icon.glow.top:SetTexture(r,g,b)
		icon.glow.bottom:SetTexture(r,g,b)
		icon.glow.left:SetTexture(r,g,b)
		icon.glow.right:SetTexture(r,g,b)
	 else 
		icon.glow:SetBackdropBorderColor(r,g,b,sh)
		icon.glow.right:SetTexture(0,0,0)
		icon.glow.top:SetTexture(0,0,0)
		icon.glow.left:SetTexture(0,0,0)
		icon.glow.bottom:SetTexture(0,0,0)
	 end
end