local HeightSpawn,gcdhe,replacePlayerBuffs,threat_ok,mk_anim

if HissyData then -- HissyUI Depends on
	HeightSpawn = HissyData.uftoggle
	replacePlayerBuffs = true
	gcdhe = HissyData.gcds
else
	HeightSpawn = 125
	gcdhe = 754
end 

local playerClass = select(2, UnitClass("player"))

local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)
	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

if (IsAddOnLoaded('oUF_ThreatBar')) then threat_ok = true end

-- Set Animation
local SetAnim = function(self,duration,a,b)
	self.anim = self:CreateAnimationGroup("Flash")
	self.anim.fadein = self.anim:CreateAnimation("ALPHA", "FadeIn")
	self.anim.fadein:SetChange(1)
	self.anim.fadein:SetOrder(b)
	self.anim.fadeout = self.anim:CreateAnimation("ALPHA", "FadeOut")
	self.anim.fadeout:SetChange(-1)
	self.anim.fadeout:SetOrder(a)
	self.anim.fadein:SetDuration(duration)
	self.anim.fadeout:SetDuration(duration)
	self.anim:SetLooping("REPEAT")
end

-- Manabar flash check
if playerClass == "DEATHKNIGHT" or playerClass == "WARRIOR" or playerClass == "ROGUE" then
	mk_anim = false
else
	mk_anim = true
end

-- Portrait Update
local PortraitPostUpdate = function(Portrait, unit)
	if not UnitIsPlayer(unit) then 
		local r, g, b = UnitSelectionColor(unit)
		Portrait.bg:SetBackdropColor(r, g, b)		
	else
		local englass = select(2, UnitClass(unit)) 
		local r, g, b = unpack(colors.class[englass])
		Portrait.bg:SetBackdropColor(r, g, b)		
	end
end

-- Update Player and Pet Pvp flags
local pvp_update = function(self,event,unit)
	if unit ~= "player" and unit ~= "pet" and event ~= "PLAYER_ENTERING_WORLD" then return end
	if not unit then
		unit = self.unit
	end
	if UnitIsPVPFreeForAll(unit) then
		self:SetBackdropColor(.93,.93,.07)
	elseif UnitIsPVP(unit) then
		self:SetBackdropColor(.07,.93,.07)
	else
		self:SetBackdropColor(.07,.07,.93)
	end
end

local mk_pvpflag = function(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_FLAGS_CHANGED")
	self:SetScript("OnEvent",pvp_update)
end

-- CastBar Upd
local castUpd = function(self)
	if self.Castbar then
		if not self.Castbar.interrupt then
			local r, g, b = UnitSelectionColor(self.unit)
			self.Castbar:SetStatusBarColor(r, g, b)
		else
			self.Castbar:SetStatusBarColor(.666, .666, .666)
		end
	end
end

-- Bg
local bg_ = function(self)
	self:SetBackdrop( {
		bgFile = Wiskas.textureblank,
		edgeFile = Wiskas.textureglow,
		edgeSize = 4, insets = { left = 3, right = 3, top = 3, bottom = 3 }}) 
	self:SetBackdropBorderColor(unpack(Wiskas.colorshadow))
	self:SetBackdropColor(unpack(Wiskas.colormain))
end

-- Health Update
local updateHealth = function(bar, unit, current, maxhp)  
	
	if (UnitIsDead(unit)) or (UnitIsGhost(unit)) or not(UnitIsConnected(unit)) then
		
		bar:SetStatusBarColor(0,0,0,0)
		bar.second:SetStatusBarColor(0.2, 0.2, 0.2, 0.68)
		bar.second:SetMinMaxValues(0,maxhp)
		bar.second:SetValue(maxhp)
		bar.second:SetAlpha(1)
		
		if bar.second.anim:IsPlaying() then
			bar.second.anim:Stop()
			bar:SetFrameLevel(6)
			bar.second:SetFrameLevel(5)
		end
		
	else
		
		bar:SetValue(maxhp-current)
		bar.second:SetMinMaxValues(0,maxhp)
		bar.second:SetValue(maxhp-current)
		
		if current == maxhp then
			bar:SetStatusBarColor(0, 0, 0, 0)
			bar.second:SetStatusBarColor(0.5, 0, 0, 0.6)
			bar.second:SetAlpha(1)
				if anim then
					bar.second.anim:Stop()
					bar:SetFrameLevel(6)
					bar.second:SetFrameLevel(5) 
				end
		else
			if (current/maxhp) <= .25 then
				if not bar.second.anim:IsPlaying() then
					bar.second.anim:Play()
					bar:SetFrameLevel(5)
					bar.second:SetFrameLevel(6)	
				end
					bar.second:SetStatusBarColor(1, 0, 0, .95)
					bar:SetStatusBarColor(0.09, 0, 0, 0.7)
			else
				if bar.second.anim:IsPlaying() then
					bar.second.anim:Stop()
					bar:SetFrameLevel(6)
					bar.second:SetFrameLevel(5)	
				end
					bar.second:SetAlpha(1)
					bar:SetStatusBarColor(0.1, 0, 0, 0.666)
					bar.second:SetStatusBarColor(0.5, 0, 0, 0.6)
			end
		end
	end
end
	
local w_dead = "|cffFFFFFFDead|r"
local w_ghost = "|cffFFFFFFGhost|r"
local w_offline = "|cffFFFFFFOffline|r"

-- Player_update_health
local player_h_upd = function(bar, unit, current, maxhp)  
	updateHealth(bar, unit, current, maxhp)
	if (UnitIsDead(unit)) then
		bar.value:SetText(w_dead)
	elseif (UnitIsGhost(unit)) then	
		bar.value:SetText(w_ghost)
	elseif not(UnitIsConnected(unit)) then 
		bar.value:SetText(w_offline) 
	else
		local a = current/maxhp
		if a > .66 then 
			bar.value:SetTextColor(.07,.93,.07)
		elseif a>.33 then
			bar.value:SetTextColor(.93,.93,.07)
		else
			bar.value:SetTextColor(.93,.07,.07)
		end
		bar.value:SetText(current)
	end
	
end

-- Target_update_health
local target_h_upd = function(bar, unit, current, maxhp)
	updateHealth(bar, unit, current, maxhp)
	if (UnitIsDead(unit)) then
		bar.value:SetText(w_dead)
	elseif (UnitIsGhost(unit)) then	
		bar.value:SetText(w_ghost)
	elseif not(UnitIsConnected(unit)) then 
		bar.value:SetText(w_offline)
	else	
		if not UnitIsPlayer(unit) then
			local r, g, b = UnitSelectionColor(unit)
			bar.value:SetTextColor(r, g, b)
		else
			local englass = select(2, UnitClass(unit))
			local r, g, b = unpack(colors.class[englass])
			bar.value:SetTextColor(r, g, b)
		end
		bar.value:SetText((current).." |cffFFFFFF"..floor(current/maxhp*100).." %|r")	
	end
end

-- afk check
local afk_check = function(self,unit)
	if (UnitIsAFK(unit)) then
		self.text:SetText("AFK ")
	else 
		self.text:SetText("")
	end
end

-- Player PvP flag check
local update_pvp = function(self,event,unit)
	if unit ~= "player" then return end
	if UnitIsPVPFreeForAll("player") then
		self:SetBackdropColor(.93,.93,.07)
	elseif UnitIsPVP("player") then
		self:SetBackdropColor(.07,.93,.07)
	else
		self:SetBackdropColor(.07,.07,.93)
	end
end

--Flash lowmana
local mk_low_mana = function(self)
	if not(mk_anim) then return end
		local flashlow = CreateFrame("Frame",nil,self.Power)
		flashlow:SetBackdrop ({edgeFile = Wiskas.textureglow, 
			edgeSize = 4, 
			insets = { left = 3, right = 3, top = 3, bottom = 3 } })
		flashlow:SetBackdropBorderColor(1,0,0,1)
		Wiskas.mkButton(flashlow,3,true)
		flashlow.left:SetTexture(1,0,0)
		flashlow.right:SetTexture(1,0,0)
		flashlow.bottom:SetTexture(1,0,0)
		flashlow.top:SetTexture(1,0,0)
		flashlow:SetAllPoints(self.Power.glow)
		flashlow:SetAlpha(0)
		flashlow:SetFrameLevel(4)
		SetAnim(flashlow,.5,2,1)
		return flashlow
end
-- Player XP
local mk_experience = function(self)
	if not(IsAddOnLoaded('oUF_Experience')) then return nil end
	
	local XP = CreateFrame('StatusBar', nil, self)
		XP:SetPoint('TOPLEFT', self, 'BOTTOMLEFT', 4, -2)
		XP:SetPoint('TOPRIGHT', self, 'BOTTOMRIGHT', -4, -2)
		XP:SetHeight(13)
		XP:SetStatusBarTexture(Wiskas.textureblank)
		XP:SetStatusBarColor(0.07, 0.5, 0.07)
		XP:SetFrameStrata("MEDIUM")
		XP.Tooltip = true
		XP.Rested = CreateFrame('StatusBar', nil, XP)
		XP.Rested:SetAllPoints(XP)
		XP.Rested:SetStatusBarTexture(Wiskas.textureblank)
		XP.Rested:SetStatusBarColor(.07,.07,0.5,1)
		XP.Text = XP:CreateFontString(nil, 'OVERLAY', 'GameFontHighlightSmall')
		XP.Text:SetPoint('CENTER', XP,0,1.3)
		XP.Rested = Wiskas.mkButton (XP.Rested,-1)
		XP.Rested:SetBackdrop({bgFile = Wiskas.textureblank})
		XP.Rested:SetBackdropColor(unpack(Wiskas.colormain))
		XP:SetScript('OnEnter', function(self) UIFrameFadeIn(self,.1,0,1) end)
		XP:SetScript('OnLeave', function(self) UIFrameFadeOut(self,.2,1,0) end)
		XP:SetAlpha(0)
		
	return XP
end

-- Player Combat/Resting
local mk_combat_resting = function(self)
	local c_ = CreateFrame ("Frame",nil,self)
	c_:SetFrameLevel(10)
	c_:SetFrameStrata("LOW")
	cr = c_:CreateFontString(nil, "OVERLAY")
	cr:SetFont(Wiskas.nfont,13)
	cr:SetShadowOffset(1,-1)
	cr:SetPoint("TOPRIGHT",self,-5.7,-2.3)
	cr:SetJustifyH("RIGHT")
	c_:RegisterEvent("PLAYER_REGEN_ENABLED")
	c_:RegisterEvent("PLAYER_REGEN_DISABLED")
	c_:RegisterEvent("PLAYER_FLAGS_CHANGED")
	c_:RegisterEvent("PLAYER_ENTERING_WORLD")
	c_:SetScript("OnEvent", function (self,event)
		if InCombatLockdown() or event == "PLAYER_REGEN_DISABLED" then
			cr:SetText("Combat")
		elseif IsResting() then
			cr:SetText("Resting")
		else
			cr:SetText("")
		end
	end)
end

-- Check Pet Model
local mk_petmodel = function(self)
	local n_ = 1
	local a = CreateFrame("Frame")
	local b = CreateFrame("Frame")
	a:SetScript("OnEvent",function()
		if arg1 ~= "player" then return end
		if not(self:IsShown()) then return end
		b:Show()
	end)
	a:RegisterEvent("UNIT_EXITED_VEHICLE")
	a:RegisterEvent("UNIT_ENTERED_VEHICLE")
	b:SetScript("OnUpdate",function(s,t)
		n_ = n_ -t
		if n_>0 then return end
			n_ = 1
			s:Hide()
			if not(self:IsShown()) then return end
			self.Portrait:SetUnit("pet")
			self.Portrait:SetCamera(0)
		end)
end
-- Player Totems
local mk_totems = function(self)
	if not(IsAddOnLoaded("oUF_TotemBar") and playerClass == "SHAMAN") then return nil end

	local lol_totem = {}
		
	for i = 1, 4 do
		lol_totem[i] = CreateFrame("StatusBar", nil, self)
		lol_totem[i]:SetHeight(6)
		lol_totem[i]:SetWidth(48)
		lol_totem[i]:SetStatusBarTexture(Wiskas.textureblank)
		lol_totem[i]:SetMinMaxValues(0, 1)
		lol_totem.Destroy = true
			
		if i ~= 1 then
			lol_totem[i]:SetPoint("LEFT",lol_totem[i-1],"RIGHT",6,0)
		end
				
		lol_totem[i].bg = lol_totem[i]:CreateTexture(nil, "BORDER")
		lol_totem[i].glow = Wiskas.frame(lol_totem[i],nil,0)
		lol_totem[i].glow:SetPoint("TOPLEFT", lol_totem[i], "TOPLEFT", -4, 4)
		lol_totem[i].glow:SetPoint("BOTTOMRIGHT", lol_totem[i], "BOTTOMRIGHT", 4, -4)
	end
		lol_totem[1]:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 4, 14)
		
	return lol_totem
	
end

-- Runes
local mk_runes = function(self) 
	if playerClass ~= "DEATHKNIGHT" then return nil end
		
	local runes = CreateFrame("Frame",nil,self)
		
	for i = 1, 6 do
		
		runes[i] = CreateFrame('StatusBar', nil, runes)
		runes[i]:SetStatusBarTexture(Wiskas.textureblank)
		runes[i]:SetWidth(30)
		runes[i]:SetHeight(6)

		if i == 1 then 
			runes[i]:SetPoint('BOTTOMLEFT', self, 'TOPLEFT', 4, 14)
		else	
			runes[i]:SetPoint('LEFT', runes[i-1], 'RIGHT', 6, 0)
		end
		runes[i].glow = CreateFrame ("Frame",nil,runes[i])
		bg_(runes[i].glow)
		runes[i].glow = Wiskas.mkButton(runes[i].glow)
		runes[i].glow:SetPoint("TOPLEFT",-4,4)
		runes[i].glow:SetPoint("BOTTOMRIGHT",4,-4)
		runes[i].glow:SetFrameLevel(0)	
	end
	return runes
end

local re_color = function(self,r,g,b,ag)
	self:SetBackdropBorderColor(r,g,b,ag or 1)
	if ag then r,g,b = 0,0,0 end
	self.Portrait.bg.top:SetTexture(r,g,b)
	self.Portrait.bg.bottom:SetTexture(r,g,b)
	self.Portrait.bg.left:SetTexture(r,g,b)
	self.Portrait.bg.right:SetTexture(r,g,b)
end

-- update trrrrrr
local function UpdateThreat(self, event, unit)
	if (self.unit ~= unit) then return end
	local threat = UnitThreatSituation(self.unit)
	if (threat == 3) then
		re_color(self,1,0,0)
	elseif (threat == 2) then
		re_color(self,1,.5,0)
	elseif (threat == 1) then
		re_color(self,1,1,0)
	else
		re_color(self,unpack(Wiskas.colorshadow))
	end 
end

-- Player_GCD (HissyUI only)
local mk_gcd = function (self)
	if not(IsAddOnLoaded("oUF_GCD") and HissyData) then return nil end
	
	local gcd = CreateFrame("StatusBar", "oUF_Player_GCD", self)
		gcd:SetHeight(6)
		gcd:SetWidth(gcdhe)
		gcd:SetPoint("BOTTOM", UIParent, 0, HeightSpawn - 76)
		gcd:SetStatusBarTexture(Wiskas.textureblank)
		gcd:SetStatusBarColor(1, 0.8, 0.15)
		gcd.mirror = CreateFrame("Frame",nil,gcd)
		
	local bg = Wiskas.frame(UIParent)
		bg:SetPoint("TOPLEFT",gcd,-4,4)
		bg:SetPoint("BOTTOMRIGHT",gcd,4,-4)
		bg:SetAlpha(0)
		bg:SetFrameLevel(gcd:GetFrameLevel()-1)
		bg:SetFrameStrata(gcd:GetFrameStrata())
		
	local green_compl = bg:CreateTexture(nil,"OVERLAY")
		green_compl:SetAllPoints(gcd)
		green_compl:SetTexture(0,1,0,1)
		
		gcd.mirror:HookScript("OnShow", function() UIFrameFadeIn(bg,0,0,1) green_compl:SetAlpha(0) end)
		gcd.mirror:HookScript("OnHide", function() UIFrameFadeOut(bg,.8,1,0) green_compl:SetAlpha(1) end)
		
	return gcd
end

-- oUF_CombatFeedback
local mk_feedback = function(self,size)
	if not(IsAddOnLoaded('oUF_CombatFeedback')) then return end

	local feed = self.level_:CreateFontString(nil, "OVERLAY")
	feed:SetPoint("CENTER", self.Portrait)
	feed:SetFont(Wiskas.sfont, size, "OUTLINE")
	feed:SetShadowOffset(1,-1)
	
	return feed
end

-- Player`s Cast check
local PlayerCastbarFade = function(self,event)

	if arg1 ~= "player" then return end

	if event == "UNIT_SPELLCAST_START" then
		self.fails = nil
		self.isokey = nil
		self.ischanneling = nil
		self:SetAlpha(0)
		self.mask:SetAlpha(1)

		if self.anim:IsPlaying() then
			self.anim:Stop()
		end

	elseif event == "UNIT_SPELLCAST_CHANNEL_START" then
		self:SetAlpha(0)
		self.mask:SetAlpha(1)

		if self.anim:IsPlaying() then
			self.anim:Stop()
		end

		self.iscasting = nil
		self.fails = nil
		self.isokey = nil

	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		self.fails = nil
		self.isokey = true
		self.fails_a = nil

	elseif (event == "UNIT_SPELLCAST_FAILED" or event == "UNIT_SPELLCAST_FAILED_QUIET") then
		self.fails = true
		self.isokey = nil
		self.fails_a = nil

	elseif (event == "UNIT_SPELLCAST_INTERRUPTED") then
		self.fails = nil
		self.isokey = nil
		self.fails_a = true

	elseif 	event == "UNIT_SPELLCAST_STOP" then
		if self.fails or self.fails_a then
			self:SetBackdropBorderColor(1,0,0,.5)
			self:SetBackdropColor(1,0,0)
		elseif self.isokey then
			self:SetBackdropBorderColor(0,1,0,.5)
			self:SetBackdropColor(0,1,0)
		end
		
		self.mask:SetAlpha(0)
		self:SetAlpha(0)

		if not self.anim:IsPlaying() then
			self.anim:Play()
		end
	
		elseif event == "UNIT_SPELLCAST_CHANNEL_STOP" then
			self.mask:SetAlpha(0)
			self:SetAlpha(0)

		if self.fails_a then
			self:SetBackdropBorderColor(1,0,0,.5)
			self:SetBackdropColor(1,0,0)

			if not self.anim:IsPlaying() then
				self.anim:Play()
			end	
		end
	end	
end

-- Create Player Fade for castbar
local set_fadecast = function(self)
	local fade = CreateFrame ("Frame",nil,self)
	fade:SetFrameLevel(9)
	fade:SetBackdrop({	bgFile = Wiskas.textureblank, 
		edgeFile = Wiskas.textureglow,
		edgeSize = 3,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	fade:SetPoint("TOPLEFT",self.Castbar,-4,4)
	fade:SetPoint("BOTTOMRIGHT",self.Castbar,4,-4)
	fade:SetAlpha(0)
	fade:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	fade:RegisterEvent("UNIT_SPELLCAST_START")
	fade:RegisterEvent("UNIT_SPELLCAST_STOP")
	fade:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	fade:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	fade:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	fade:RegisterEvent("UNIT_SPELLCAST_FAILED")
	fade:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
	fade.mask = CreateFrame ("Frame",nil,self)
	fade.mask:SetBackdrop({bgFile = Wiskas.textureblank,})
	fade.mask:SetPoint("TOPLEFT",self.Castbar)
	fade.mask:SetPoint("BOTTOMRIGHT",self.Castbar)
	fade.mask:SetAlpha(0)
	fade.mask:SetFrameLevel(9)
	fade.mask:SetBackdropColor(1, 0.7, 0.1)
	fade.anim = fade:CreateAnimationGroup("Flash")
	fade.anim.fadein = fade.anim:CreateAnimation("ALPHA", "FadeIn")
	fade.anim.fadein:SetChange(1)
	fade.anim.fadein:SetOrder(1)
	fade.anim.fadeout1 = fade.anim:CreateAnimation("ALPHA", "FadeOut")
	fade.anim.fadeout1:SetChange(-.25)
	fade.anim.fadeout1:SetOrder(2)
	fade.anim.fadeout2 = fade.anim:CreateAnimation("ALPHA", "FadeOut")
	fade.anim.fadeout2:SetChange(-.75)
	fade.anim.fadeout2:SetOrder(3)
	fade.anim.fadein:SetDuration(0)
	fade.anim.fadeout1:SetDuration(.8)
	fade.anim.fadeout2:SetDuration(.4)
	fade:SetScript("OnEvent", function(self,event) PlayerCastbarFade(self,event) end)
end

-- Power Update
local updatePower = function(bar, unit, min, max)
	if UnitIsDead(unit) or UnitIsGhost(unit) or not(UnitIsConnected(unit)) then
		bar:SetValue(0)
		if bar.value then
			bar.value:SetText(" ")
		end
		if unit == "player" and mk_anim then
			if bar.flashlow.anim:IsPlaying() then
				bar.flashlow.anim:Finish()
				bar.flashlow:SetAlpha(0) 				
			end
		end	
	else
		bar:SetValue(min)
		if unit == "player" then
			bar.value:SetText(min)
			if mk_anim then
				if min/max <= .33 then
					if not bar.flashlow.anim:IsPlaying()  then
						bar.flashlow.anim:Play() 
					end
				else
					if bar.flashlow.anim:IsPlaying() then
						bar.flashlow.anim:Finish()
						bar.flashlow:SetAlpha(0) 
					end
				end			
			end
		elseif unit =="target" then
			local tclass = select(2, UnitClass(unit))
			if (not(UnitIsPlayer(unit)) and (tclass == "PALADIN")) or UnitIsPlayer(unit) then
				bar.value:SetText(min.." ")
			else
				bar.value:SetText(" ")
			end
		end
		local ptype = select(2, UnitPowerType(unit))
		if(colors.power[ptype]) then
			local r, g, b = unpack(colors.power[ptype])
			bar:SetStatusBarColor(r, g, b)
			if bar.value then
				bar.value:SetTextColor(r, g, b)
			end
		end
		if unit == "pet" and playerClass == "HUNTER" then
			local happy = GetPetHappiness()
			if happy then
				bar:SetStatusBarColor(unpack(colors.happiness[happy]))
			end
		end
	end
end

-- Druid Mana
local n_ = 0
local UpdateDruidMana = function(self,t,flashlow)
	n_ = n_ - t
	if n_ > 0 then return end
	local num, str = UnitPowerType("player")
		if num ~= 0 then
			local min = UnitPower("player", 0)
			local max = UnitPowerMax("player", 0)
			mk_anim = false
				if min~=max then
					self.value:SetText(" "..min)
					self:SetAlpha(1)
				else
					self:SetAlpha(0)
				end
				if min/max < .33 then
					if not(flashlow.anim:IsPlaying()) then
						flashlow.anim:Finish()
						flashlow:SetAlpha(1)
					end
				else
					if flashlow.anim:IsPlaying() then
						flashlow.anim:Finish()
						flashlow:SetAlpha(0)
					end
				end
		else
			self:SetAlpha(0)
			mk_anim = true
		end
	n_ = .2
end

local mk_swing = function(self)
	if not(IsAddOnLoaded("oUF_Swing")) then return end
		local swing = CreateFrame ("StatusBar",nil,self)
		swing:SetStatusBarTexture(Wiskas.textureblank)
		swing:SetStatusBarColor(.4,.4,.4,.333)
		swing:SetAllPoints(self.Castbar)
		swing:SetFrameLevel(4)
		return swing
end

local mk_spark = function(self)
	if not(IsAddOnLoaded('oUF_PowerSpark')) then return end
		local spark = self.Power:CreateTexture(nil, "OVERLAY")
		spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		spark:SetVertexColor(.75, .75, 1, .8)
		spark:SetBlendMode("ADD")
		spark:SetHeight(self.Power:GetHeight()*3.4)
		spark:SetWidth(self.Power:GetHeight()+4)
		return spark
end

-- Create Cats Bar
local create_cast_bar = function(self,unit)
	if unit == "focustarget" or unit == "targettarget" then return end
	
	local cast = CreateFrame("StatusBar", nil, self)
	cast:SetFrameLevel(10)
	
	if unit=="player" then
		cast:SetPoint("TOPLEFT",self, "BOTTOMLEFT", 4, -2)
		cast:SetPoint("TOPRIGHT",self,"BOTTOMRIGHT", -4, -2)
		cast:SetHeight(13)
	elseif unit == "target" then
		cast:SetPoint("BOTTOMLEFT",self, "TOPLEFT", 23, 2)
		cast:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT", -4, 2)
		cast:SetHeight(13)
	elseif unit == "focus" then
		cast:SetPoint("CENTER", UIParent, 0, 122)
		cast:SetHeight(16)
		cast:SetWidth(200)
	else
		cast:SetPoint("BOTTOMRIGHT", self, "BOTTOMLEFT", -14, 4)
		cast:SetPoint("TOPRIGHT", self,"TOPLEFT", -14, -4)
		cast:SetWidth(6)
		cast:SetOrientation("VERTICAL")
	end
	
	cast:SetStatusBarTexture(Wiskas.textureblank)
	cast:SetStatusBarColor(1, 0.7, 0.1)
			
	if (unit == "focus" or unit == "pet") then
		cast.bg = Wiskas.frame(cast,nil,0)
		cast.bg:SetPoint("TOPLEFT",-4,4)
		cast.bg:SetPoint("BOTTOMRIGHT",4,-4)
		Wiskas.mkButton(cast.bg)
	end			

	if unit ~= "target" then
		cast:SetBackdrop({bgFile = Wiskas.textureblank})
		cast:SetBackdropColor(unpack(Wiskas.colormain))
		Wiskas.mkButton(cast,-1)
	end

	cast.iconbg = CreateFrame("Frame",nil,cast)
			
	if unit~="player" and unit~="pet" then
		if unit == "target" then
			cast:SetScript("OnShow", function(s) 
				castUpd(s) 
				self.isf:SetAlpha(0) 
				self.info:SetAlpha(0)
				self.Power.value:SetAlpha(0) 
				self.Health.value:SetAlpha(0)
			end)
			cast:SetScript("OnHide", function(s) 
				self.isf:SetAlpha(1) 
				self.info:SetAlpha(1) 
				self.Power.value:SetAlpha(1) 
				self.Health.value:SetAlpha(1) 
			end)
		else
			cast:SetScript("OnShow", castUpd)
		end
	end

	cast.Icon = cast.iconbg:CreateTexture(nil, "BORDER")
	cast.Icon:SetTexCoord(.1,.9,.1,.9)
	cast.Icon:SetGradient("VERTICAL",.5,.5,.5,1,1,1)

	if unit=="player" then
		cast.iconbg:SetPoint("TOPRIGHT",cast,"TOPLEFT",-2,4)
		cast.iconbg:SetWidth(36)
		cast.iconbg:SetHeight(36)
	elseif unit == "target" then
		cast.iconbg:SetPoint("RIGHT",cast,"LEFT",-2,0)
		cast.iconbg:SetWidth(21)
		cast.iconbg:SetHeight(21)
		cast.Icon:SetTexCoord(.2,.8,.2,.8)
	local bg = Wiskas.frame(cast)
		bg:SetPoint("TOPLEFT",-4,4)
		bg:SetPoint("BOTTOMRIGHT",4,-4)
		bg:SetFrameLevel(9)
		bg:SetFrameStrata(cast:GetFrameStrata())
	elseif unit == "focus" then
		cast.iconbg:SetPoint("BOTTOM",cast,"TOP",0,2)
		cast.iconbg:SetWidth(38)
		cast.iconbg:SetHeight(38)
	end	
	
	bg_(cast.iconbg)
	Wiskas.mkButton(cast.iconbg,nil,true)
	
	cast.Time = cast:CreateFontString(nil, "OVERLAY")
	cast.Time:SetTextColor(1, 1, 1)
	cast.Time:SetShadowOffset(1, -1)

	if not (unit == "pet") then
		cast.Icon:SetPoint("TOPLEFT", cast.iconbg, 4, -4)
		cast.Icon:SetPoint("BOTTOMRIGHT",cast.iconbg, -4, 4)	
		cast.Time:SetPoint("RIGHT",cast, -2, 1.3)
		cast.Time:SetFont(Wiskas.nfont, 13)
		cast.Time:SetJustifyH("RIGHT")
		cast.Text = cast:CreateFontString(nil, "OVERLAY")
		cast.Text:SetPoint("LEFT",cast, 1.5, 1.3)
		cast.Text:SetPoint("RIGHT",cast.Time,"LEFT", -1, 0)
		cast.Text:SetFont(Wiskas.nfont, 13)
		cast.Text:SetShadowOffset(1, -1)
		cast.Text:SetTextColor(1, 1, 1)
		cast.Text:SetJustifyH("LEFT")
		cast.Spark = cast:CreateTexture(nil, "OVERLAY")
		cast.Spark:SetWidth(8)
		cast.Spark:SetBlendMode("ADD")
		cast.Spark:SetAlpha(.666)
		
		if unit == "focus" then
			cast.Time:SetFont(Wiskas.nfont, 14)
			cast.Text:SetFont(Wiskas.nfont, 14)
		end

	else
		cast.Time:SetPoint("CENTER", self, 0, 1.3)
		cast.Time:SetFont(Wiskas.nfont, 14)
		cast.Time:SetJustifyH("CENTER")
		cast.Icon:SetAllPoints(self.Portrait)
		cast.Icon:SetAlpha(.333)
	end
	
	return cast
end

-- DruidMana
local mk_druid = function(self)
	if not(playerClass == "DRUID") then return end
	local druid = CreateFrame("Frame",nil,self)
		druid.value = druid:CreateFontString(nil, "OVERLAY")
		druid.value:SetShadowOffset(1, -1)
		druid.value:SetPoint("LEFT",self.Power.value,"RIGHT")
		druid.value:SetPoint("RIGHT",self.Health.value,"LEFT")
		druid.value:SetFont(Wiskas.nfont,13)
		druid.value:SetJustifyH("LEFT")
		druid.value:SetTextColor(.2, .4, 1)
		local fl = self.Power.flashlow
		druid:SetScript("OnUpdate",function(self,t) UpdateDruidMana(self,t,fl) end)
end

-- ComboPoints
local mk_cc_points = function(self)
	if not(playerClass=="ROGUE" or playerClass=="DRUID") then return end
		local cpoints = self.level_:CreateFontString(nil, "OVERLAY")
		cpoints:SetFont(Wiskas.nfont, 33)
		cpoints:SetTextColor(1, 0.9, 0.1)
		cpoints:SetShadowOffset(1, -1)
		cpoints:SetJustifyH("RIGHT")
		cpoints:SetPoint("RIGHT",self,-6.7,2.3)
		self:Tag(cpoints, '[cpoints]')
end

-- Create Ri
local mk_ricon = function(self)
	local r = self.level_:CreateTexture(nil, "OVERLAY")
		r:SetHeight(24)
		r:SetWidth(24)
		r:SetPoint("CENTER", self.Health,"TOP")
		r:SetVertexColor(1,1,1,.666)
		r:SetTexture"Interface\\TargetingFrame\\UI-RaidTargetingIcons"
	return r
end
	
--Threat
local mk_threat = function(self)
	if not(threat_ok) then return end
		local trtr = CreateFrame("StatusBar",self:GetName()..'_ThreatBar',self)
		trtr:SetStatusBarTexture(Wiskas.textureblank)
		trtr:SetBackdrop({bgFile = Wiskas.textureblank})
		trtr:SetBackdropColor(unpack(Wiskas.colormain))
		Wiskas.mkButton(trtr,-1)
		trtr.Text = trtr:CreateFontString(nil, 'OVERLAY')
		trtr.Text:SetFont(Wiskas.nfont,13)
		trtr.Text:SetShadowOffset(1,-1)
		trtr.Text:SetJustifyH("LEFT")
		trtr:SetFrameLevel(8)
		trtr.Text:SetPoint("BOTTOMLEFT",trtr,"TOPLEFT",.3,21.3)
		trtr.useRawThreat = false
		return trtr
end

--heal_4
local mk_hell_4 = function(self,unit)
	if not(IsAddOnLoaded("oUF_HealComm4")) then return end
		local text = self.level_:CreateFontString(nil, 'OVERLAY')
		text:SetFont(Wiskas.sfont,19,"OUTLINE")
		text:SetTextColor(0, 1, 0)
		if not(unit=="player") then 
			text:SetPoint('TOP', self.Health,"BOTTOM", 0, 7)
		else 
			text:SetPoint('BOTTOM', self.Health,"TOP", 0, -7) 
		end
		self.allowHealCommOverflow = true
	return text
end

-- Unit Spec.
local UnitSpecific = {

	--[								]--
	player = function(self)
		
		self.Health.PostUpdate = player_h_upd
		
		self.isf:SetPoint ("TOPLEFT",self,"BOTTOMLEFT", 0, 2)
		self.isf:SetPoint ("TOPRIGHT",self,"BOTTOMRIGHT", 0, 2)
		self.isf:SetHeight(21)
		
		mk_combat_resting(self)
		mk_pvpflag(self.Portrait.bg)
		self.Runes = mk_runes(self)
		self.TotemBar = mk_totems(self)
		self.Experience = mk_experience(self)
		self.Swing = mk_swing(self)
		self.GCD = mk_gcd(self)
		self.ThreatBar = mk_threat(self)
		
		self.Castbar.SafeZone = self.Castbar:CreateTexture(nil, "ARTWORK")
		self.Castbar.SafeZone:SetAllPoints(self.Castbar)
		self.Castbar.SafeZone:SetTexture(.666,0,0,.444)

		local H_value = self.Health:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1, -1)
			H_value:SetFont(Wiskas.nfont,13)
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("TOPRIGHT",self,"BOTTOMRIGHT",-6.2,-.3)
		self.Health.value = H_value

		local P_value = self.Power:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1, -1)
			P_value:SetFont(Wiskas.nfont,13)
			P_value:SetJustifyH("LEFT")
			P_value:SetPoint("TOPLEFT",self,"BOTTOMLEFT",4.9,-.3)
		self.Power.value = P_value
		
		self.Power.flashlow = mk_low_mana(self)
		mk_druid(self)
		
		local leader = self.level_:CreateFontString(nil, "OVERLAY")
			leader:SetFont(Wiskas.nfont,13)
			leader:SetShadowOffset(1,-1)
			leader:SetPoint("TOPLEFT",self,4.7,-2.3)
			leader:SetText("Leader")
			leader:SetJustifyH("LEFT")
		self.Leader = leader
		
		local aura = CreateFrame("Frame",nil,self)
	
		if (playerClass == 'DEATHKNIGHT') or  (IsAddOnLoaded("oUF_TotemBar") and playerClass == "SHAMAN") then
			aura:SetPoint("BOTTOMLEFT",self.Power,"TOPLEFT", -1, 17)
			aura:SetPoint("BOTTOMRIGHT",self.Power,"TOPRIGHT", 1, 17)
		else
	        aura:SetPoint("BOTTOMLEFT",self.Power,"TOPLEFT", -1, 5)
			aura:SetPoint("BOTTOMRIGHT",self.Power,"TOPRIGHT", 1, 5)
		end
		
		aura.initialAnchor = "BOTTOMRIGHT"
		aura["growth-x"] = "LEFT"
		aura["growth-y"] = "UP"
		aura.numBuffs = 0
		aura.numDebuffs = 12
		aura.spacing = 4
		aura.size = 32
		aura:SetHeight(aura.size*2+4)
		aura.cbt = true
		
		self.Power:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT",-4,2)
		self.Power:SetPoint("BOTTOMLEFT",self,"TOPLEFT",4,2)
		self.Power:SetHeight (6)
		
		self.Auras = aura
		self.Auras.PostCreateIcon = Wiskas.auraIcon
		self.Auras.PostUpdateIcon = Wiskas.auraUpdateIcon
		
		if replacePlayerBuffs == true then
			local buff = CreateFrame("Frame", nil, self)
			buff.initialAnchor = "BOTTOMRIGHT"
			buff["growth-x"] = "LEFT"
			buff["growth-y"] = "DOWN"
			buff.spacing = 4
			buff.size = 32
			buff.numBuffs = 30
			buff:SetWidth(320+4*9)
			buff:SetHeight(28*3+8)
			buff:SetPoint("TOPRIGHT",Minimap,"TOPLEFT",-5,61)
			BuffFrame:Hide()
			buff.cc_font_size = 13
			self.Buffs = buff
			self.Buffs.PostCreateIcon = Wiskas.auraIcon
			self.Buffs.PostUpdateIcon = Wiskas.auraUpdateIcon
		end
		
		self:SetWidth(218)
      	self:SetHeight(36)
		self.Spark = mk_spark(self)
		set_fadecast(self)
		self.CombatFeedbackText = mk_feedback(self,20)
		
		table.insert(self.__elements, UpdateThreat)
		self:RegisterEvent('PLAYER_TARGET_CHANGED', UpdateThreat)
		self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', UpdateThreat)
		self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', UpdateThreat)
	
	end,
	
	--[								]--
	
	target = function(self)
		
		self.Health.PostUpdate = target_h_upd
		
		self.isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT", 0, -2)
		self.isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT", 0, -2)
		self.isf:SetHeight (21)
		
		local H_value = self.Health:CreateFontString(nil, "OVERLAY")
			H_value:SetShadowOffset(1, -1)
			H_value:SetFont(Wiskas.nfont,13)
			H_value:SetJustifyH("RIGHT")
			H_value:SetPoint("RIGHT",-2,28)
		self.Health.value = H_value
		
		local P_value = self.Power:CreateFontString(nil, "OVERLAY")
			P_value:SetShadowOffset(1, -1)
			P_value:SetFont(Wiskas.nfont,13)
			P_value:SetJustifyH("LEFT")
			P_value:SetPoint("RIGHT",self.Health.value,"LEFT",0,0)
		self.Power.value = P_value
		
		self.info:SetPoint("BOTTOMLEFT",self,"TOPLEFT", 5, 3.3)
		self.info:SetPoint("TOPRIGHT",self.Power.value,"TOPLEFT", -2, 0)
		self:Tag(self.info, "|cfffed100[smartlevel]|r [name]")
		
		self.Power:SetPoint("TOPRIGHT",self,"BOTTOMRIGHT",-4,-2)
		self.Power:SetPoint("TOPLEFT",self,"BOTTOMLEFT",4,-2)
		self.Power:SetHeight (6)
		
		local afk_tag = CreateFrame("Frame",nil,self)
		afk_tag:SetFrameLevel(8)
		
		local afktext = afk_tag:CreateFontString (nil,"OVERLAY")
		afktext:SetFont(Wiskas.nfont,13)
		afktext:SetShadowOffset(1,-1)
		afktext:SetPoint("TOPLEFT",self,4.5,-2.3)
		afktext:SetJustifyH("LEFT")
		afktext:SetHeight(13)
		
		afk_tag:RegisterEvent("PLAYER_FLAGS_CHANGED")
		afk_tag:SetScript("OnEvent",function(self)
		if arg1 ~= "target" then return end
			afk_check(self,arg1)
		end)
	
		self.afktag = afk_tag
		self.afktag.text = afktext
		
		local linfo = afk_tag:CreateFontString(nil, "OVERLAY")
			linfo:SetJustifyH("LEFT")
			linfo:SetFont(Wiskas.nfont, 13)
			linfo:SetShadowOffset(1, -1)
			self:Tag(linfo,"[leaderlong]")
			linfo:SetPoint("BOTTOMLEFT",self.afktag.text,"BOTTOMRIGHT",-1,0)
			linfo:SetHeight(13)
			
		local aura = CreateFrame("Frame", nil, self)
		aura:SetPoint("TOPLEFT", self,"BOTTOMLEFT", 3, -13)
		aura:SetPoint("TOPRIGHT", self,"BOTTOMRIGHT", -3, -13)
		aura.initialAnchor = "TOPLEFT"
		aura["growth-x"] = "RIGHT"
		aura["growth-y"] = "DOWN"
		aura.numBuffs = 10
		aura.numDebuffs = 10
		aura.spacing = 4
		aura.size = 24
		aura:SetHeight(aura.size*2+4)
		aura.cc_font_size = 11
		self.Auras = aura
		self.Auras.PostCreateIcon = Wiskas.auraIcon
		self.Auras.PostUpdateIcon = Wiskas.auraUpdateIcon
		
		mk_cc_points(self)
		
		self:SetWidth(282)
      	self:SetHeight(36)
		
		self.CombatFeedbackText = mk_feedback(self,20)
		
	end,
	
	--[								]--
	
	pet = function(self)
		
		self.Health.PostUpdate = updateHealth
		
		self.Power:SetPoint("TOPRIGHT",self,"TOPLEFT",-2,-4)
		self.Power:SetWidth(6)
		self.Power:SetHeight (40)
		
		local aura = CreateFrame("Frame", nil, self)
		aura:SetPoint("BOTTOMLEFT", self,"TOPLEFT", -9, 1)
		aura:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", -3, 1)
		aura.initialAnchor = "BOTTOMRIGHT"
		aura["growth-x"] = "LEFT"
		aura["growth-y"] = "UP"
		aura.numBuffs = 0
		aura.numDebuffs = 4
		aura.spacing = 4
		aura.size = 25
		aura:SetHeight(aura.size*2+4)
		aura.cc_font_size = 12
		aura.cbt = true
		self.Auras = aura
		self.Auras.PostCreateIcon = Wiskas.auraIcon
		self.Auras.PostUpdateIcon = Wiskas.auraUpdateIcon
		
		self:SetWidth(48)
      	self:SetHeight(48)
		self.Power:SetOrientation("VERTICAL")
		self.Health:SetOrientation("VERTICAL")
		self.Health.second:SetOrientation("VERTICAL")
		
		self.CombatFeedbackText = mk_feedback(self,16)
		mk_petmodel(self)
		mk_pvpflag(self.Portrait.bg)
		
		table.insert(self.__elements, UpdateThreat)
		self:RegisterEvent('PLAYER_TARGET_CHANGED', UpdateThreat)
		self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', UpdateThreat)
		self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', UpdateThreat)
	end,
	
	--[								]--
	
	focus = function(self)
		
		self.Health.PostUpdate = updateHealth
		
		self.isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT", 0, -2)
		self.isf:SetWidth (92)
		self.isf:SetHeight	(21)
		
		self.Power:SetPoint("BOTTOMRIGHT",self,"BOTTOMLEFT",-2,4)
		self.Power:SetPoint("TOPRIGHT",self,"TOPLEFT",-2,-4)
		self.Power:SetWidth(14)
		
		self.info:SetPoint("BOTTOMLEFT",self,"TOPLEFT", -15.5, 3.3)
		self.info:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT", -5, 3.3)
		self.info:SetJustifyH("CENTER")
		self:Tag(self.info, "[name]")
		
		self:SetWidth(72)
		self:SetHeight(48)
		self.Power:SetOrientation("VERTICAL")
		self.Health:SetOrientation("VERTICAL")
		self.Health.second:SetOrientation("VERTICAL")
		
		self.CombatFeedbackText = mk_feedback(self,16)
		
	end,
	
	--[								]--
	
	focustarget = function(self)
	
		self.isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT", 0, -2)
		self.isf:SetPoint ("BOTTOMRIGHT",self,"TOPRIGHT", 0, -2)
		self.isf:SetHeight (21)
		
		self.info:SetPoint("BOTTOMLEFT",self,"TOPLEFT", 4.5, 3.3)
		self.info:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT", -4.7, 3.3)
		self.info:SetJustifyH("CENTER")
		self:Tag(self.info, "[name]")
		
		self:SetWidth(92)
		self:SetHeight(39)
		
	end,
	
	--[								]--
	
	targettarget = function(self)
		
		self.Health.PostUpdate = updateHealth
		
		self.isf:SetPoint ("BOTTOMLEFT",self,"TOPLEFT", 0, -2)	
		self.isf:SetWidth (92)
		self.isf:SetHeight(21)
		
		self.Power:SetPoint("BOTTOMLEFT",self,"BOTTOMRIGHT",2,4)
		self.Power:SetPoint("TOPLEFT",self,"TOPRIGHT",2,-4)
		self.Power:SetWidth(14)
		
		self.info:SetPoint("BOTTOMLEFT",self,"TOPLEFT", 5, 3.3)
		self.info:SetPoint("BOTTOMRIGHT",self,"TOPRIGHT", 15.5, 3.3)
		self.info:SetJustifyH("CENTER")
		self:Tag(self.info, "[name]")
		
		self:SetWidth(72)
		self:SetHeight(48)
		self.Power:SetOrientation("VERTICAL")
		self.Health:SetOrientation("VERTICAL")
		self.Health.second:SetOrientation("VERTICAL")
		
		
	end,
}

-- Style func
local style = function(self,unit)

	self.menu = menu
	self.disallowVehicleSwap = true
	self:SetScale(Wiskas.ufscale)
	self:RegisterForClicks("anyup")
	self:SetAttribute("*type2", "menu")
	self:SetFrameStrata("LOW")
	self:SetFrameLevel(0)
	bg_(self)
	
	self:SetScript('OnEnter',UnitFrame_OnEnter)
	self:SetScript('OnLeave',UnitFrame_OnLeave)
	
	local level = CreateFrame("Frame",nil,self)
	level:SetFrameStrata("LOW")
	level:SetFrameLevel(11)
	self.level_ = level

	local portrait = CreateFrame("PlayerModel",nil,self)
		portrait:SetPoint("TOPLEFT",4,-4)
		portrait:SetPoint("BOTTOMRIGHT",-4,4)
		portrait:SetFrameLevel(4)
		portrait:SetAlpha(1)
		portrait.bg = CreateFrame("Frame",nil,portrait)
		portrait.bg:SetAllPoints(portrait)
		Wiskas.mkButton(portrait.bg,-1,nil,"BLEND")
		portrait.bg.bg:SetGradientAlpha("VERTICAL",0,0,0,0,0,0,0,.666)
		portrait.bg:SetBackdrop({bgFile = Wiskas.texturewall, tile = true, tileSize = 50})
		portrait.bg:SetAlpha(1)
		portrait.bg:SetFrameLevel(3)
	self.Portrait = portrait
	
	if (unit~="player") then
		if (IsAddOnLoaded('oUF_SpellRange')) then 	
			self.SpellRange = {["insideAlpha"] = 1,["outsideAlpha"] = .777,}
		end
		self.Portrait.PostUpdate = PortraitPostUpdate
		local info = self:CreateFontString(nil, "OVERLAY")
		info:SetFont(Wiskas.nfont, 13)
		info:SetJustifyH("LEFT")
		info:SetShadowOffset(1, -1)
		self.info = info
	end
	
	if unit ~= "pet" then
		self.isf = Wiskas.frame(self,nil,0)
	end
	
	if unit == "player" or unit == "pet" then
		self.Portrait.bg.unit = unit
	end
	
	self.Castbar = create_cast_bar(self,unit)
	
	local hp = CreateFrame("StatusBar", nil, self)
		hp:SetStatusBarTexture(Wiskas.textureblank)
		hp:SetAllPoints(self.Portrait)
		hp:SetFrameLevel(6)
		hp:SetStatusBarColor(0,0,0,0)	
		hp.Smooth = true
		hp.second = CreateFrame("StatusBar",nil,hp)
		hp.second:SetFrameLevel(5)
		hp.second:SetAllPoints(self.Portrait)
		hp.second:SetStatusBarTexture(Wiskas.textureblank)
		hp.second:SetStatusBarColor(0,0,0,0)
		SetAnim(hp.second,.3,1,2)
	self.Health = hp
	
	if unit~= "focustarget" then
	
	local pp = CreateFrame("StatusBar", nil, self)
		pp:SetFrameLevel(3)
		pp:SetStatusBarTexture(Wiskas.textureblank)
		pp.glow = Wiskas.frame(pp,nil,2)
		pp.glow:SetPoint("TOPRIGHT",4,4)
		pp.glow:SetPoint("BOTTOMLEFT",-4,-4)
		pp.frequentUpdates = true
		pp.Smooth = true
		self.Power = pp
		self.Power.PostUpdate = updatePower
		
	end
	
	self.RaidIcon = mk_ricon(self)
	
	self.HealCommText = mk_hell_4(self,unit)
	self.MoveableFrames = true
	
	return UnitSpecific[unit](self)

end

oUF:RegisterStyle("Alley",style)

local show_fade = function(self)
	if not InCombatLockdown() then
		UIFrameFadeIn(self,.1,0,self:GetAlpha())
	end
end

local t1,t2

oUF:Factory(function(self)
	self:SetActiveStyle"Alley"
	self:Spawn"player":SetPoint("BOTTOM", UIParent, "BOTTOM", -338, 53+HeightSpawn)
	self.units.player:HookScript("OnShow",show_fade)
	self:Spawn"target":SetPoint("BOTTOM", UIParent, "BOTTOM", 0, HeightSpawn)
	self.units.target:HookScript("OnShow",show_fade)
	self:Spawn"targettarget":SetPoint("LEFT",self.units.target, "RIGHT", -2, -6)
	self.units.targettarget:HookScript("OnShow",show_fade)
	self:Spawn"focus":SetPoint("RIGHT",self.units.target, "LEFT", 2, -6)
	self.units.focus:HookScript("OnShow",show_fade)
	self:Spawn"focustarget":SetPoint("TOPRIGHT",self.units.focus,"BOTTOMRIGHT", 0, -17)
	self.units.focustarget:HookScript("OnShow",show_fade)
	self:Spawn"pet":SetPoint("TOPRIGHT",self.units.player, "TOPLEFT", 2, 12)
	self.units.pet:HookScript("OnShow",show_fade)
	if threat_ok then
		self.units.player.ThreatBar:SetParent(self.units.target.level_)
		self.units.player.ThreatBar:SetAllPoints(self.units.target.Power)
		t1 = self.units.player.ThreatBar
	end
	t2 = self.units.target.afktag
end)
	
local t = CreateFrame("Frame")

local change = function()
		afk_check(t2,"target")
	if not UnitIsPlayer("target") and threat_ok then
		t1:SetAlpha(1)
	elseif threat_ok then
		t1:SetAlpha(0)
	end
end

t:SetScript("OnEvent",change)
t:RegisterEvent("PLAYER_TARGET_CHANGED")
